Index: /strings_mod.F90
===================================================================
--- /strings_mod.F90	(revision 1)
+++ /strings_mod.F90	(revision 2)
@@ -1300,5 +1309,5 @@
 END FUNCTION real2str
 !==============================================================================================================================
-ELEMENTAL CHARACTER(LEN=256) FUNCTION dble2str(d,fmt) RESULT(out)
+ELEMENTAL CHARACTER(LEN=maxlen) FUNCTION dble2str(d,fmt) RESULT(out)
   DOUBLE PRECISION,           INTENT(IN) :: d
   CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: fmt
@@ -1367,5 +1376,5 @@
   CHARACTER(LEN=*),   INTENT(IN)  :: message, items, reason
   INTEGER,  OPTIONAL, INTENT(IN)  :: nmax
-  CHARACTER(LEN=256), ALLOCATABLE :: s(:)
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: s(:)
   INTEGER :: i, nmx
   nmx = 256; IF(PRESENT(nmax)) nmx=nmax
Index: /trac_types_mod.F90
===================================================================
--- /trac_types_mod.F90	(revision 1)
+++ /trac_types_mod.F90	(revision 2)
@@ -1,47 +1,55 @@
 MODULE trac_types_mod
 
+  USE strings_mod, ONLY: maxlen
+  PRIVATE
+
 !=== TRACERS DESCRIPTOR DERIVED TYPE AND ASSOCIATED ROUTINES INTERFACES =======================================================
-  PRIVATE
-  PUBLIC :: tra, iso, kys
+  PUBLIC :: trac_type, isot_type, keys_type
 !------------------------------------------------------------------------------------------------------------------------------
-  TYPE kys                                                           !=== TYPE FOR A SET OF KEYS ASSOCIATED TO AN ELEMENT
-    CHARACTER(LEN=256)              :: name                          !--- Tracer name
-    CHARACTER(LEN=256), ALLOCATABLE :: key(:)                        !--- Keys string list
-    CHARACTER(LEN=256), ALLOCATABLE :: val(:)                        !--- Corresponding values string list
-  END TYPE kys
+  TYPE :: keys_type                                        !=== TYPE FOR A SET OF KEYS ASSOCIATED TO AN ELEMENT
+    CHARACTER(LEN=maxlen)              :: name             !--- Tracer name
+    CHARACTER(LEN=maxlen), ALLOCATABLE :: key(:)           !--- Keys string list
+    CHARACTER(LEN=maxlen), ALLOCATABLE :: val(:)           !--- Corresponding values string list
+  END TYPE keys_type
 !------------------------------------------------------------------------------------------------------------------------------
-  TYPE tra                                                           !=== TYPE FOR SINGLE TRACER
-    CHARACTER(LEN=256)   :: name = ''                                !--- Name
-    CHARACTER(LEN=256)   :: nam1 = ''                                !--- Generation 1 ancestor name
-    CHARACTER(LEN=256)   :: prnt = ''                                !--- Parent name
-    CHARACTER(LEN=256)   :: lnam = ''                                !--- Long name (with adv. scheme)
-    CHARACTER(LEN=256)   :: type = 'tracer'                          !--- Type (so far: 'tracer'/'tag')
-    CHARACTER(LEN=256)   :: phas = 'g'                               !--- Phase ('g'as/'l'iquid/'s'olid)
-    CHARACTER(LEN=256)   :: comp                                     !--- Coma-separated list of components (Ex: lmdz,inca)
-    INTEGER              :: iadv = 10                                !--- Advection scheme used
-    INTEGER              :: igen = 1                                 !--- Generation number (>=1)
-    INTEGER              :: itr  = 0                                 !--- Index in tr_seri (0: not in physics)
-    INTEGER              :: iprnt = 0                                !--- Parent index
-    INTEGER, ALLOCATABLE :: idesc(:)                                 !--- Descendants index (in growing generation order)
-    INTEGER              :: ndesc = 0                                !--- Number of descendants (all generations)
-    INTEGER              :: nchld = 0                                !--- Number of childs    (first generation)
-    INTEGER              :: iso_igr = 0                              !--- Isotopes group index in isotopes(:)
-    INTEGER              :: iso_num = 0                              !--- Isotope  name  index in isotopes(iso_igr)%trac(:)
-    INTEGER              :: iso_zon = 0                              !--- Isotope  zone  index in isotopes(iso_igr)%zone(:)
-    INTEGER              :: iso_pha = 0                              !--- Isotope  phase index in isotopes(iso_igr)%phas
-    TYPE(kys)            :: keys                                     !--- <key>=<val> pairs vector
-  END TYPE tra
+  TYPE :: trac_type                                        !=== TYPE FOR A SINGLE TRACER NAMED "name"
+    CHARACTER(LEN=maxlen) :: name        = ''      	   !--- Name of the tracer
+    CHARACTER(LEN=maxlen) :: gen0Name    = ''      	   !--- First generation ancestor name
+    CHARACTER(LEN=maxlen) :: parent      = ''      	   !--- Parent name
+    CHARACTER(LEN=maxlen) :: longName    = ''      	   !--- Long name (with advection scheme suffix)
+    CHARACTER(LEN=maxlen) :: type        = 'tracer'	   !--- Type  (so far: 'tracer' / 'tag')
+    CHARACTER(LEN=maxlen) :: phase       = 'g'     	   !--- Phase ('g'as / 'l'iquid / 's'olid)
+    CHARACTER(LEN=maxlen) :: component             	   !--- Coma-separated list of components (Ex: lmdz,inca)
+    INTEGER               :: iadv        = 10      	   !--- Advection scheme used
+    INTEGER               :: iGeneration = 1       	   !--- Generation number (>=1)
+    LOGICAL               :: isAdvected  = .FALSE. 	   !--- "true" tracers: iadv > 0 . COUNT(     isAdvected) =nqtrue
+    LOGICAL               :: isH2Ofamily = .FALSE. 	   !--- H2O tracers/isotopes/tags. COUNT(.NOT.isH2Ofamily)=nqtottr
+    INTEGER               :: iqParent    = 0       	   !--- Parent index
+    INTEGER,  ALLOCATABLE :: iqDescen(:)           	   !--- Descendants index (in growing generation order)
+    INTEGER               :: nqDescen    = 0       	   !--- Number of descendants (all generations)
+    INTEGER               :: nqChilds    = 0       	   !--- Number of childs    (first generation)
+    INTEGER               :: iso_iGroup  = 0       	   !--- Isotopes group index in isotopes(:)
+    INTEGER               :: iso_iName   = 0       	   !--- Isotope  name  index in isotopes(iso_iGroup)%trac(:)
+    INTEGER               :: iso_iZone   = 0       	   !--- Isotope  zone  index in isotopes(iso_iGroup)%zone(:)
+    INTEGER               :: iso_iPhase  = 0       	   !--- Isotope  phase index in isotopes(iso_iGroup)%phas
+    TYPE(keys_type)       :: keys                          !--- <key>=<val> pairs vector
+  END TYPE trac_type
 !------------------------------------------------------------------------------------------------------------------------------
-  TYPE iso                                                           !=== TYPE FOR ISOTOPES FAMILY DESCENDING ON TRACER "prnt"
-    CHARACTER(LEN=256)              :: prnt                          !--- Isotopes family name (parent tracer name ; ex: H2O)
-    LOGICAL                         :: check=.FALSE.                 !--- Triggering of the checking routines
-    TYPE(kys),          ALLOCATABLE :: keys(:)                       !--- Isotopes keys/values pairs list (length: niso)
-    CHARACTER(LEN=256), ALLOCATABLE :: trac(:)                       !--- Isotopes + tagging tracers list (length: nitr)
-    CHARACTER(LEN=256), ALLOCATABLE :: zone(:)                       !--- Geographic tagging zones names list
-    CHARACTER(LEN=256)              :: phas = 'g'                    !--- Phases list: [g][l][s]
-    INTEGER                         :: niso=0, nzon=0, nitr=0, npha=0!--- Number of isotopes, zones, total isotopes and phases
-    INTEGER,            ALLOCATABLE :: iTraPha(:,:)   ! (iqiso)      !--- Idx in "trac(1:niso)" = f(name(1:nitr)),phas)
-    INTEGER,            ALLOCATABLE :: iZonIso(:,:)   ! (index_trac) !--- Idx in "trac(1:nitr)" = f(zone, name(1:niso))
-  END TYPE iso
+  TYPE :: isot_type                                        !=== TYPE FOR AN ISOTOPES FAMILY DESCENDING ON TRACER "parent"
+    CHARACTER(LEN=maxlen)              :: parent           !--- Isotopes family name (parent tracer name ; ex: H2O)
+    LOGICAL                            :: check=.FALSE.    !--- Triggering of the checking routines
+    TYPE(keys_type),       ALLOCATABLE :: keys(:)          !--- Isotopes keys/values pairs list     (length: niso)
+    CHARACTER(LEN=maxlen), ALLOCATABLE :: trac(:)          !--- Isotopes + tagging tracers list     (length: nitr)
+    CHARACTER(LEN=maxlen), ALLOCATABLE :: zone(:)          !--- Geographic tagging zones names list (length: nzon)
+    CHARACTER(LEN=maxlen)              :: phase = 'g'      !--- Phases list: [g][l][s]              (length: npha)
+    INTEGER                            :: niso = 0         !--- Number of isotopes, excluding tagging tracers
+    INTEGER                            :: nzon = 0         !--- Number of geographic tagging zones
+    INTEGER                            :: nitr = 0         !--- Number of isotopes, including tagging tracers
+    INTEGER                            :: npha = 0         !--- Number phases
+    INTEGER,               ALLOCATABLE :: iTraPha(:,:)     !--- Idx in "trac(1:niso)" = f(name(1:nitr)),phas)
+                                                           !---        "iTraPha" former name: "iqiso"
+    INTEGER,               ALLOCATABLE :: iZonIso(:,:)     !--- Idx in "trac(1:nitr)" = f(zone, name(1:niso))
+                                                           !---        "iZonIso" former name: "index_trac"
+  END TYPE isot_type
 
 END MODULE trac_types_mod
